class ProgramModel {
  WelcomeMessage _welcomeMessage;
  bool _active;
  bool _public;
  List<String> _users;
  List<String> _selfSubscribed;
  List<Tags> _tags;
  String _sId;
  String _name;
  String _description;
  String _imageUrl;
  String _subscribeLinkId;
  bool _enableLinkSubscribe;
  String _createdAt;
  String _updatedAt;
  int _iV;
  String _id;

  ProgramModel(
      {WelcomeMessage welcomeMessage,
      bool active,
      bool public,
      List<String> users,
      List<String> selfSubscribed,
      List<Tags> tags,
      String sId,
      String name,
      String description,
      String imageUrl,
      String subscribeLinkId,
      bool enableLinkSubscribe,
      String createdAt,
      String updatedAt,
      int iV,
      String id}) {
    this._welcomeMessage = welcomeMessage;
    this._active = active;
    this._public = public;
    this._users = users;
    this._selfSubscribed = selfSubscribed;
    this._tags = tags;
    this._sId = sId;
    this._name = name;
    this._description = description;
    this._imageUrl = imageUrl;
    this._subscribeLinkId = subscribeLinkId;
    this._enableLinkSubscribe = enableLinkSubscribe;
    this._createdAt = createdAt;
    this._updatedAt = updatedAt;
    this._iV = iV;
    this._id = id;
  }

  WelcomeMessage get welcomeMessage => _welcomeMessage;
  set welcomeMessage(WelcomeMessage welcomeMessage) =>
      _welcomeMessage = welcomeMessage;
  bool get active => _active;
  set active(bool active) => _active = active;
  bool get public => _public;
  set public(bool public) => _public = public;
  List<String> get users => _users;
  set users(List<String> users) => _users = users;
  List<String> get selfSubscribed => _selfSubscribed;
  set selfSubscribed(List<String> selfSubscribed) =>
      _selfSubscribed = selfSubscribed;
  List<Tags> get tags => _tags;
  set tags(List<Tags> tags) => _tags = tags;
  String get sId => _sId;
  set sId(String sId) => _sId = sId;
  String get name => _name;
  set name(String name) => _name = name;
  String get description => _description;
  set description(String description) => _description = description;
  String get imageUrl => _imageUrl;
  set imageUrl(String imageUrl) => _imageUrl = imageUrl;
  String get subscribeLinkId => _subscribeLinkId;
  set subscribeLinkId(String subscribeLinkId) =>
      _subscribeLinkId = subscribeLinkId;
  bool get enableLinkSubscribe => _enableLinkSubscribe;
  set enableLinkSubscribe(bool enableLinkSubscribe) =>
      _enableLinkSubscribe = enableLinkSubscribe;
  String get createdAt => _createdAt;
  set createdAt(String createdAt) => _createdAt = createdAt;
  String get updatedAt => _updatedAt;
  set updatedAt(String updatedAt) => _updatedAt = updatedAt;
  int get iV => _iV;
  set iV(int iV) => _iV = iV;
  String get id => _id;
  set id(String id) => _id = id;

  ProgramModel.fromJson(Map<String, dynamic> json) {
    _welcomeMessage = json['welcomeMessage'] != null
        ? new WelcomeMessage.fromJson(json['welcomeMessage'])
        : null;
    _active = json['active'];
    _public = json['public'];
    _users = json['users'].cast<String>();
    _selfSubscribed = json['selfSubscribed'].cast<String>();
    if (json['tags'] != null) {
      _tags = new List<Tags>();
      json['tags'].forEach((v) {
        _tags.add(new Tags.fromJson(v));
      });
    }
    _sId = json['_id'];
    _name = json['name'];
    _description = json['description'];
    _imageUrl = json['image_url'];
    _subscribeLinkId = json['subscribeLinkId'];
    _enableLinkSubscribe = json['enableLinkSubscribe'];
    _createdAt = json['created_at'];
    _updatedAt = json['updated_at'];
    _iV = json['__v'];
    _id = json['id'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this._welcomeMessage != null) {
      data['welcomeMessage'] = this._welcomeMessage.toJson();
    }
    data['active'] = this._active;
    data['public'] = this._public;
    data['users'] = this._users;
    data['selfSubscribed'] = this._selfSubscribed;
    if (this._tags != null) {
      data['tags'] = this._tags.map((v) => v.toJson()).toList();
    }
    data['_id'] = this._sId;
    data['name'] = this._name;
    data['description'] = this._description;
    data['image_url'] = this._imageUrl;
    data['subscribeLinkId'] = this._subscribeLinkId;
    data['enableLinkSubscribe'] = this._enableLinkSubscribe;
    data['created_at'] = this._createdAt;
    data['updated_at'] = this._updatedAt;
    data['__v'] = this._iV;
    data['id'] = this._id;
    return data;
  }
}

class WelcomeMessage {
  int _startAfter;
  String _conversation;
  int _startAfterTimestamp;

  WelcomeMessage(
      {int startAfter, String conversation, int startAfterTimestamp}) {
    this._startAfter = startAfter;
    this._conversation = conversation;
    this._startAfterTimestamp = startAfterTimestamp;
  }

  int get startAfter => _startAfter;
  set startAfter(int startAfter) => _startAfter = startAfter;
  String get conversation => _conversation;
  set conversation(String conversation) => _conversation = conversation;
  int get startAfterTimestamp => _startAfterTimestamp;
  set startAfterTimestamp(int startAfterTimestamp) =>
      _startAfterTimestamp = startAfterTimestamp;

  WelcomeMessage.fromJson(Map<String, dynamic> json) {
    _startAfter = json['startAfter'];
    _conversation = json['conversation'];
    _startAfterTimestamp = json['startAfterTimestamp'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['startAfter'] = this._startAfter;
    data['conversation'] = this._conversation;
    data['startAfterTimestamp'] = this._startAfterTimestamp;
    return data;
  }
}

class Tags {
  String _id;
  String _text;

  Tags({String id, String text}) {
    this._id = id;
    this._text = text;
  }

  String get id => _id;
  set id(String id) => _id = id;
  String get text => _text;
  set text(String text) => _text = text;

  Tags.fromJson(Map<String, dynamic> json) {
    _id = json['id'];
    _text = json['text'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this._id;
    data['text'] = this._text;
    return data;
  }
}
