import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:risecx_chat_client/models/messages/messages.dart';
import 'package:risecx_chat_client/styles.dart';

class MenusMessageWidget extends StatefulWidget {
  final dynamic message;
  final Function onPayloadPress;
  const MenusMessageWidget({Key key, this.message, this.onPayloadPress})
      : super(key: key);

  @override
  _MenusMessageWidgetState createState() =>
      _MenusMessageWidgetState();
}

class _MenusMessageWidgetState extends State<MenusMessageWidget> {
  MenusMessageModel _menuModel;

  @override
  Widget build(BuildContext context) {
    _menuModel = MenusMessageModel.fromJson(widget.message);
    return Card(
        child: Column(
      children: <Widget>[
        Padding(
          child:
              Text(_menuModel.text, style: Styles.messageTitleTextStyle),
          padding: Styles.massageTitlePadding,
        ),
        Column(
          children: buttons(),
        )
      ],
    ));
  }

  menusBtn(Menus menu) {
    return SizedBox(
        width: double.infinity,
        child: Padding(
            padding: EdgeInsets.symmetric(horizontal: 10.0),
            child: OutlineButton(
              child: Text(menu.title),
              onPressed: (){
                print(menu.title);
                print(menu.payload);
                widget.onPayloadPress(menu);
              },
            )));
  }

  List<Widget> buttons() {
    List<Widget> btnsList = new List();
    if (_menuModel.menus != null)
      _menuModel.menus
          .forEach((menu) => btnsList.add(menusBtn(menu)));
    return btnsList;
  }
}
