import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:risecx_chat_client/models/models.dart';
import 'package:risecx_chat_client/widgets/widgets.dart';

class SentMessageWidget extends StatefulWidget {
  final dynamic message;
  const SentMessageWidget({Key key, this.message}) : super(key: key);

  @override
  _SentMessageWidgetState createState() => _SentMessageWidgetState();
}

class _SentMessageWidgetState extends State<SentMessageWidget> {
  @override
  Widget build(BuildContext context) {
    TextMessageModel textModel = TextMessageModel.fromJson(widget.message);
    double cWidth = MediaQuery.of(context).size.width * 0.8;
    return Row(
      children: <Widget>[
        Container(
          height: 50.0,
          width: 50.0,
          child: new CircleAvatar(
            backgroundColor: Colors.transparent,
            foregroundColor: Colors.red,
            radius: 100.0,
          ),
          decoration: BoxDecoration(
              border: Border.all(
                color: Colors.white,
                width: 3.0,
              ),
              shape: BoxShape.circle,
              image: new DecorationImage(
                image: _userImageAvatar,
                fit: BoxFit.cover,
              )),
        ),
        Container(
            padding: const EdgeInsets.all(16.0),
            width: cWidth,
            child: Bubble(
              margin: BubbleEdges.only(top: 10),
              color: Color.fromARGB(255, 225, 255, 199),
              nip: BubbleNip.leftTop,
              child: Text(textModel.text),
            )),
      ],
    );
  }

  ImageProvider get _userImageAvatar =>
      new AssetImage('assets/images/default-user.jpg',
          package: 'risecx_chat_client');
}
