import 'commons.dart';

class Payload {
  String templateType;
  String topElementStyle;
  String url;
  String text;
  List<Elements> elements;
  List<Buttons> buttons;
  List<ModalAnswers> modalAnswers;

  Payload({
    this.templateType,
    this.topElementStyle,
    this.url,
    this.elements,
    this.buttons,
  });

  Payload.fromJson(Map<String, dynamic> json) {
    templateType = json['template_type'];
    topElementStyle = json['top_element_style'];
    url = json['url'];
    text = json['text'];
    if (json['elements'] != null) {
      elements = new List<Elements>();
      json['elements'].forEach((v) {
        elements.add(new Elements.fromJson(v));
      });
    }
    if (json['buttons'] != null) {
      buttons = new List<Buttons>();
      json['buttons'].forEach((v) {
        buttons.add(new Buttons.fromJson(v));
      });
    }
    if (json['modalAnswers'] != null) {
      modalAnswers = new List<ModalAnswers>();
      json['modalAnswers'].forEach((v) {
        modalAnswers.add(new ModalAnswers.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['template_type'] = this.templateType;
    data['top_element_style'] = this.topElementStyle;
    data['url'] = this.url;
    data['text'] = this.text;
    if (this.elements != null) {
      data['elements'] = this.elements.map((v) => v.toJson()).toList();
    }
    if (this.buttons != null) {
      data['buttons'] = this.buttons.map((v) => v.toJson()).toList();
    }
    if (this.modalAnswers != null) {
      data['modalAnswers'] = this.modalAnswers.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class ModalAnswers {
  String contentType;
  String title;
  String payload;

  ModalAnswers({this.contentType, this.title, this.payload});

  ModalAnswers.fromJson(Map<String, dynamic> json) {
    contentType = json['content_type'];
    title = json['title'];
    payload = json['payload'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['content_type'] = this.contentType;
    data['title'] = this.title;
    data['payload'] = this.payload;
    return data;
  }
}
